<!--
  Service component wrapper that catches and
  handles application errors
-->
<template>
  <Feedback
    v-for="error in errors"
    :key="error.id"
    :message="error.message"
    type="error"
    variant="snackbar"
    @close="onFeedbackClose(error.id)"
  />

  <slot />
</template>

<script setup lang="ts">
import { reactive, onErrorCaptured, onBeforeMount } from 'vue';
import { useRouter } from 'vue-router';

import { AxiosError } from 'axios';
import { nanoid } from 'nanoid';

import Feedback from '@/components/content/Feedback.vue';

import { useAuth } from '@/composables';
import { sleep } from '@/utils';

type ErrorBoundaryEntry = {
  id: string;
  message: string;
}

const router = useRouter();
const auth = useAuth();

const errors = reactive<ErrorBoundaryEntry[]>([]);

const onFeedbackClose = async (id: string) => {
  const targetIndex = errors.findIndex(error => error.id === id);
  if (targetIndex < 0) return;

  // Sleep to not interrupt Feedback close animation
  await sleep(500);
  errors.splice(targetIndex, 1);
};

const isUnauthorizedError = (error: AxiosError) => {
  const responseData = error.response!.data as any;
  const statusCode = responseData?.error?.statusCode as number ?? 500;

  return statusCode === 401;
};

const handleError = (error: unknown) => {
  const isAxiosError = error instanceof AxiosError;

  if (!isAxiosError) {
    const message = (error as Error).message;

    errors.push({ id: nanoid(8), message });

    // eslint-disable-next-line no-unused-expressions
    import.meta.env.DEV
      ? console.error(error)
      : console.warn(`Error: ${message}`);

    return false;
  }

  const errorData = error.response!.data.error ?? {
    error: 'Ошибка',
    message: 'Не удалось выполнить запрос',
  };

  const message = `${errorData.error}: ${errorData.message}`;

  errors.push({ id: nanoid(8), message });
  console.warn(message);

  if (isUnauthorizedError(error)) {
    auth.logout();
    router.push('/login');
  }

  return false;
};

onErrorCaptured(handleError);

onBeforeMount(() => {
  window.addEventListener('unhandledrejection', (event: PromiseRejectionEvent) => {
    handleError(event.reason);
  });
});
</script>
